# Animate Menu Plugin

This unofficial TaleSpire plugin for triggering animations from the radial menu. Animations are auto detected or specified
in a configuration file by BoardAssetId. Supports rigged, blendshape and sound.

This plugin, like all others, is free but if you want to donate, use: http://LordAshes.ca/TalespireDonate/Donate.php

## Change Log

```
1.0.0: Initial release
```

## Install

Use R2ModMan or similar installer to install this plugin.

## Usage

1. Select the mini. This is required at least once before opening the mini's radial menu.
2. Right click the mini to open the radial menu.
3. Select the animations selection
4. If animations are available they will be listed.
5. Select the desired animation to trigger it.

## Automatic Configuration

If a file named after the BoardAssetId with an extension of ``Animate`` is not found for the selected mini then the
animations are detected automatically and ordered in alphabetical order.

Note: Animations are detected the first time the mini is selected.

## Manual Configuration

To provide a manual configruation for an asset, create a file with the BoardAssetId and an extention of ``Animate``.
The board asset id can be obtained from the plugin's logs or from the index.json files generated by CALP (if the feature
is turned on in the CALP configuration). The format of the file is as follows:
```
[
	{"name": "Fly", "rigged": 1, "blendShape": null, "sound": -1},
	{"name": "Breath", "rigged": 2, "blendShape": null, "sound": -1},
	{"name": "Idle", "rigged": 3, "blendShape": null, "sound": -1}
]
```

Where ``name`` is the name that will appear in the menu.
Where ``rigged`` is the name or index of the rigged animation to be triggered. Set to null to not trigger an animation.
Set to -1 to stop a rigged animation.
Where ``blendShape`` is the index of the blend shape animation to be triggered. Set to null to not trigger an animation.
Set to -1 to stop a rigged animation.
Where ``sound`` indicates if a sound will be played. Set to 1 to play a sound. Set to 0 to stop playing a sound.
Set to -1 to not change the current sound.

The rigged animation value works a little oddly due to CALPIE's interpretation of the value. It can be a animation name
or an animation index. If it is a name, this plugin converts it to an index before sending it to CALPIE. However, CALPIE
interprets the index as follows:

First it checks to see if the Animation Names list (configured in CALPIE) and uses the index to look up the corresponding
name. If the selected creature contains an animation with that name, that is the animation that is triggered.
Next it checks to see if the selected creature contains an animation called Anim followed by the index as a two digit
number. If it exists, that is what is triggered.
Lastly the index in used to select a animation from the creatures animation list at the index element. Note that indexes
start at 1 (and not 0).

What does this mean? If you animations are making use of the Animation Names in CALPIE then use the name or index from that
list. If your creature is using Anim01, Anim02, ... then use the corresponding number. If your creaure is using unique names
(not in the Animate Names and not matching Anim##) then use the animation name.